import { UsersService } from "./users.service";
import { CreateUserDto } from "./dto/create-user.dto";
import { UpdateUserDto } from "./dto/update-user.dto";
import { CaptureRecordIndexDto } from "../../common/options/find-options.dto";
import { User } from "./entities/user.entity";
import { ChangePasswordDto } from "./dto/change-password.dto";
import { AuthService } from "../auth.service";
export declare class UsersController {
    private readonly usersService;
    private readonly authService;
    constructor(usersService: UsersService, authService: AuthService);
    create(createUserDto: CreateUserDto): Promise<unknown>;
    findAll(params: CaptureRecordIndexDto<User>): Promise<any>;
    findOne(id: string): Promise<{
        statusCode: import("@nestjs/common").HttpStatus;
        message: string;
        success: boolean;
        result: User;
    } | {
        statusCode: import("@nestjs/common").HttpStatus;
        message: string;
        success: boolean;
        error: any;
    }>;
    updateRecord(id: string, updateUserDto: UpdateUserDto): Promise<unknown>;
    update(id: string, updateUserDto: UpdateUserDto): Promise<unknown>;
    remove(id: string): Promise<unknown>;
    changePassword(changePaswwordDto: ChangePasswordDto, request: any): Promise<unknown>;
}
