import { HttpStatus } from "@nestjs/common";
import { ChangePasswordDto } from "./dto/change-password.dto";
import { CreateUserDto } from "./dto/create-user.dto";
import { UpdateUserDto } from "./dto/update-user.dto";
import { User } from "./entities/user.entity";
export declare class UsersService {
    private readonly user;
    constructor(user: typeof User);
    create(createUserDto: CreateUserDto): Promise<unknown>;
    findAll(query: any): Promise<any>;
    findOne(id: number): Promise<{
        statusCode: HttpStatus;
        message: string;
        success: boolean;
        result: User;
    } | {
        statusCode: HttpStatus;
        message: string;
        success: boolean;
        error: any;
    }>;
    findByUsername(username: string): Promise<any>;
    update(id: number, updateUserDto: UpdateUserDto): Promise<unknown>;
    remove(id: number): Promise<unknown>;
    changePassword(changePasswordDto: ChangePasswordDto, user: any): Promise<unknown>;
}
