"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const moment_timezone_1 = __importDefault(require("moment-timezone"));
class UtilityService {
    getAge(dob) {
        const today = moment_timezone_1.default();
        const date_of_birth = moment_timezone_1.default(dob);
        const ages = moment_timezone_1.default.duration(today.diff(date_of_birth));
        const age = ages.years();
        const month = ages.months();
        const day = ages.days();
        return { age, month, day };
    }
    getSystemConfig() {
        return __awaiter(this, void 0, void 0, function* () {
            const firm_id = 0;
            const financil_year_id = 3;
            const system_config = {
                firm_id,
                financil_year_id,
            };
            return Object.assign({}, system_config);
        });
    }
}
exports.UtilityService = UtilityService;
