"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const core_menus_service_1 = require("./core-menus.service");
const common_2 = require("../../common");
const auth_service_1 = require("../../auth/auth.service");
let CoreMenusController = class CoreMenusController extends common_2.BaseController {
    constructor(coreMenusService, s, authService) {
        super(s);
        this.coreMenusService = coreMenusService;
        this.s = s;
        this.authService = authService;
    }
    getMenus(role_id, request) {
        return __awaiter(this, void 0, void 0, function* () {
            const token = request.headers.authorization;
            const user = yield this.authService.tokenDecode(token);
            return yield this.coreMenusService
                .getMenus(user)
                .then((result) => {
                return result;
            })
                .catch((error) => {
                console.log(error);
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    error,
                };
            });
        });
    }
    restore(id) {
        return this.coreMenusService
            .restore(+id)
            .then((result) => {
            return {
                statusCode: common_1.HttpStatus.OK,
                message: "success",
                result,
            };
        })
            .catch((error) => {
            return {
                statusCode: common_1.HttpStatus.BAD_REQUEST,
                message: "failed",
                error,
            };
        });
    }
};
__decorate([
    common_1.Get("get-menus"),
    __param(0, common_1.Query()), __param(1, common_1.Request()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", Promise)
], CoreMenusController.prototype, "getMenus", null);
__decorate([
    common_1.Patch(":id"),
    __param(0, common_1.Param("id")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], CoreMenusController.prototype, "restore", null);
CoreMenusController = __decorate([
    common_1.Controller("core-menus"),
    __metadata("design:paramtypes", [core_menus_service_1.CoreMenusService,
        core_menus_service_1.CoreMenusService,
        auth_service_1.AuthService])
], CoreMenusController);
exports.CoreMenusController = CoreMenusController;
